from datetime import date
from pessoa import Pessoa

class Adotante(Pessoa):
    def __init__(self, nome, cpf, endereco, data_de_nascimento, tipo_moradia, outros_animais):
        super().__init__(nome, cpf, endereco, data_de_nascimento)

        self.__tipo_moradia = None
        if isinstance(tipo_moradia, str):
            self.__tipo_moradia = tipo_moradia
        else:
            raise ValueError("Tipo de moradia deve ser uma string")

        self.__outros_animais = None
        if isinstance(outros_animais, bool):
            self.__outros_animais = outros_animais
        else:
            raise ValueError("Outros animais deve ser um valor booleano")
        

    @property
    def tipo_moradia(self):
        return self.__tipo_moradia

    @tipo_moradia.setter
    def tipo_moradia(self, tipo_moradia: str):
        if isinstance(tipo_moradia, str):
            self.__tipo_moradia = tipo_moradia
        else:
            raise ValueError("Tipo de moradia deve ser uma string")

    @property
    def outros_animais(self):
        return self.__outros_animais

    @outros_animais.setter
    def outros_animais(self, outros_animais: bool):
        if isinstance(outros_animais, bool):
            self.__outros_animais = outros_animais
        else:
            raise ValueError("Outros animais deve ser um valor booleano")