from animal import *
from porte import Porte

class Cachorro(Animal):
    def __init__(self, id, nome, raca, porte, vacinas):
        super().__init__(id, nome, raca, vacinas)
        
        self.__porte = None
        if isinstance(porte, Porte):
            self.__porte = porte
        else:
            raise ValueError("Porte deve ser um dos valores do enum Porte.")
        
    

    @property
    def porte(self):
        return self.__porte

    @porte.setter
    def porte(self, value):
        if isinstance(value, Porte):
            self.__porte = value
        else:
            raise ValueError("Porte deve ser um dos valores do enum Porte.")